Is Python3.9 planned for FreeCAD0.20

Having trouble installing or compiling FreeCAD? Get help here.
rendetto
Posts: 5
Joined: Mon May 17, 2021 10:02 am

Is Python3.9 planned for FreeCAD0.20

Postby rendetto » Mon May 17, 2021 11:05 am

Hello, after weekly build 24612, FreeCAD seem reverted back to using py3.8.
Is py3.9 planned for the near future?

Thanks
openBrain
Posts: 5925
Joined: Fri Nov 09, 2018 5:38 pm

Re: Is Python3.9 planned for FreeCAD0.20

Postby openBrain » Mon May 17, 2021 2:44 pm

What would be the advantage?
rendetto
Posts: 5
Joined: Mon May 17, 2021 10:02 am

Re: Is Python3.9 planned for FreeCAD0.20

Postby rendetto » Mon May 17, 2021 3:54 pm

openBrain wrote: Mon May 17, 2021 2:44 pm What would be the advantage?
There is a complex and extremely powerful pipeline around the usage of Sverchok inside Blender enabling parametric and freeform modelling including some FreeCAD/OCC functionalities (via the FreeCAD Python API). There is also a working direct connection between the FreeCAD files and Sverchok node trees.

The latest Blender builds already use python3.9 and in order to use the FreeCAD/OCC functionalities, the used FreeCAD libraries need to be built against py3.9 also.

Currently we are stuck using FreeCAD_0.19.19697_x64_Conda_Py3QT5-WinVS2015 with Blender2.92 (as those are py3.7 aligned), which are really old.
User avatar
looo
Posts: 3653
Joined: Mon Nov 11, 2013 5:29 pm

Re: Is Python3.9 planned for FreeCAD0.20

Postby looo » Mon May 17, 2021 4:24 pm

We are building conda-packages weekly for py39(win/osx/linux) and py38 (win). The windows bundle uses py38 because py39 doesn't run on win7 (iif I can remember correctly)
rendetto
Posts: 5
Joined: Mon May 17, 2021 10:02 am

Re: Is Python3.9 planned for FreeCAD0.20

Postby rendetto » Mon May 17, 2021 8:23 pm

looo wrote: Mon May 17, 2021 4:24 pm We are building conda-packages weekly for py39(win/osx/linux)
Will Conda installer create the full bundle as the one from the download section?
Because I'm not aware that someone successfully used the Conda thing with Sverchok.

On the other hand I successfully run Sverchok using only those full bundles:
FreeCAD_0.19.19697_x64_Conda_Py3QT5-WinVS2015 (py37) + Blender2.92 (py37)
FreeCAD_weekly-builds-24612-Win-Conda_vc14.x-x86_64 (py39) + Blender2.93 (py39)

Thanks
User avatar
looo
Posts: 3653
Joined: Mon Nov 11, 2013 5:29 pm

Re: Is Python3.9 planned for FreeCAD0.20

Postby looo » Tue May 18, 2021 7:32 am

rendetto wrote: Mon May 17, 2021 8:23 pm Will Conda installer create the full bundle as the one from the download section?
we use this command to create the env:
https://github.com/FreeCAD/FreeCAD-Bund ... .bat#L6L17

So the bundle contain some additional libraries.


It would be nice to create a conda-recipe for blender too. This way it would be much easier to have compatible versions available.

In addition you can also run the script to create the bundle locally. Simple remove the python pinning or set it to 3.9... Offering another bundle for python3.9 is not what I want to do. We already have too many different bundles...
rendetto
Posts: 5
Joined: Mon May 17, 2021 10:02 am

Re: Is Python3.9 planned for FreeCAD0.20

Postby rendetto » Wed May 19, 2021 7:47 am

Thank you looo. I used the .bat file from the link you gave.
It successfully generated Blender2.93 compatible FreeCAD0.20, just setting the python pinning to 3.9(as you proposed).

What I got are two folders - fc_env and FreeCAD_Conda_Build. The fc_env folder seems compatible with Blender, but the folder FreeCAD_Conda_Build is not.

What is the difference between those two folders? Should I keep both, because those are fairly big.

Thanks
User avatar
Petrikas
Posts: 49
Joined: Sat Dec 05, 2020 8:05 pm

Re: Is Python3.9 planned for FreeCAD0.20

Postby Petrikas » Sun Jun 06, 2021 3:27 pm

looo wrote: Tue May 18, 2021 7:32 am
rendetto wrote: Mon May 17, 2021 8:23 pm Will Conda installer create the full bundle as the one from the download section?
we use this command to create the env:
https://github.com/FreeCAD/FreeCAD-Bund ... .bat#L6L17

So the bundle contain some additional libraries.


It would be nice to create a conda-recipe for blender too. This way it would be much easier to have compatible versions available.

In addition you can also run the script to create the bundle locally. Simple remove the python pinning or set it to 3.9... Offering another bundle for python3.9 is not what I want to do. We already have too many different bundles...
Hello,
I'm in a similar boat rendetto is.

I'm trying to get FCimport to work on Blender, but it requires that both programs run the same python version. I'm running a Windows machine.

Blender is currently running Python 3.9

Is there a way to build FreeCAD with Python 3.9? I've tried running the .bat, but I lack the knowledge to get FreeCAD running (missing core elements like PySide and all the workbenches, etc.). I'm not familiar with terminology around FreeCAD builds.

On a side note, I might be completely incorrect here, but isn't it a bit silly to not upgrade FreeCAD to py3.9 just because Win7 won't run it? Win7 is a deprecated OS that isn't even supported by Microsoft themselves.
I sometimes make FreeCAD Tutorials | Let's improve FreeCAD's UI!
GeneFC
Posts: 2160
Joined: Sat Mar 19, 2016 3:36 pm
Location: Punta Gorda, FL

Re: Is Python3.9 planned for FreeCAD0.20

Postby GeneFC » Sun Jun 06, 2021 4:04 pm

Petrikas wrote: Sun Jun 06, 2021 3:27 pm On a side note, I might be completely incorrect here, but isn't it a bit silly to not upgrade FreeCAD to py3.9 just because Win7 won't run it? Win7 is a deprecated OS that isn't even supported by Microsoft themselves.
This has been discussed many times.

Windows 7 may be old, but it is not COVID. And who needs MS "support" in any case???

There are numerous FreeCAD users who for various reasons cannot easily upgrade. No doubt at some point it will be decided that FreeCAD must move ahead just as it did for Windows XP and for 32 bit systems.

At the current time it seems a bit silly that FreeCAD is expected to cater to Blender whims while shutting out many current users.

Python is an anti-social disaster, but that is a discussion for another time.

Gene
User avatar
Petrikas
Posts: 49
Joined: Sat Dec 05, 2020 8:05 pm

Re: Is Python3.9 planned for FreeCAD0.20

Postby Petrikas » Sun Jun 06, 2021 4:16 pm

GeneFC wrote: Sun Jun 06, 2021 4:04 pm
Petrikas wrote: Sun Jun 06, 2021 3:27 pm On a side note, I might be completely incorrect here, but isn't it a bit silly to not upgrade FreeCAD to py3.9 just because Win7 won't run it? Win7 is a deprecated OS that isn't even supported by Microsoft themselves.
This has been discussed many times.

Windows 7 may be old, but it is not COVID. And who needs MS "support" in any case???

There are numerous FreeCAD users who for various reasons cannot easily upgrade. No doubt at some point it will be decided that FreeCAD must move ahead just as it did for Windows XP and for 32 bit systems.

At the current time it seems a bit silly that FreeCAD is expected to cater to Blender whims while shutting out many current users.

Python is an anti-social disaster, but that is a discussion for another time.

Gene
expected to cater to Blender
Blender is an open-source giant, that is simply up-to-date. But sure, call it a whim.

So I understand that I can't even compile for Python 3.9, because the libpack with 3.9 is no longer available?
Builds with 3.9 also existed, but they were taken down?
I sometimes make FreeCAD Tutorials | Let's improve FreeCAD's UI!